/*
Copyright (C) 2010 Filip 'RocketGuy' Juresa

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/* minor modifications by cortex */

#define RG_BAN

#if defined(_WIN32)
#include <windows.h>
#elif defined (NeXT)
#include <sys/socket.h>
#include <arpa/inet.h>
#elif defined (MACOSX)
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#else
#ifndef AF_INET
#define AF_INET 		2	/* internet */
struct in_addr
{
	union
	{
		struct { unsigned char s_b1,s_b2,s_b3,s_b4; } S_un_b;
		struct { unsigned short s_w1,s_w2; } S_un_w;
		unsigned long S_addr;
	} S_un;
};
#define	s_addr	S_un.S_addr	/* can be used for most tcp & ip code */
struct sockaddr_in
{
    short			sin_family;
    unsigned short	sin_port;
	struct in_addr	sin_addr;
    char			sin_zero[8];
};
char *inet_ntoa(struct in_addr in);
unsigned long inet_addr(const char *cp);
#endif
#endif

#ifndef INADDR_NONE
#define INADDR_NONE ((unsigned long) -1)
#endif

typedef struct banaddr_s
{
	unsigned long addr;
	unsigned long mask;
} banaddr_t;

banaddr_t *Ban_Alloc (void);
void Ban_Cleanup (unsigned int num);
void Ban_LoadFromFile (void);
void Ban_WriteToFile (void);
void NET_Addip (unsigned long addr, unsigned long mask);
void NET_Addip_f (void);
void NET_Unban_f (void);
void NET_Banlist_f (void);
void Host_Kickban_f (void);
void Ban_Init (void);
void Ban_Shutdown (void);

unsigned int num_bans;
banaddr_t *ban_list;
